<?php
/*
	Skillaquire.txt Importer to MSSQL Database
	Author: MoSs

	Purpose: This file imports the skillacquire.txt
	into a MSSQL database so then you can easily
	add/edit/delete skills.

	You can use freely this file and distribute it
	as long as you DONT REMOVE THIS COMMENT!

	change the values to the below variables
	according to your settings and also make sure
	you create a new database to be used

	IMPORTANT: convert skillacquire.txt to ANSI Charset first!

	Place the skillacquire.txt to the same path as this
	php script.

	IMPORTANT: Using this script assumes tha your skillacquire.txt
	file does not have any logical or syntax errors and works ok
	with your server.
	This script does not check for errors in the skillacquire file.
*/

include("config.php");

$dbconn = mssql_connect($dbhostname,$dbusername,$dbpassword);
$db = mssql_select_db($dbname,$dbconn);

$handle = fopen($inputfilename,"rb");
$contents = fread($handle, filesize($inputfilename));

$contents = mb_convert_encoding($contents,"ASCII","Unicode");
if($contents{0}=="?")
	$contents = substr($contents,1);

$skillLines = explode("\n", $contents);
$headers = array();
$class_list = array();
$classCount = 0;

mssql_query("if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[class_list]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
			drop table [dbo].[class_list]");

mssql_query("CREATE TABLE [dbo].[class_list] (
			[class_name] [varchar] (255),
			[includes] [varchar] (255)
			) ON [PRIMARY]");

// First find all the classes and import them into db and into an array
for($i=0;$i<count($skillLines);$i++){
	if(substr(trim($skillLines[$i]),-6)=="_begin" && substr(trim($skillLines[$i]),0,5)!="skill"){
		if(substr(trim($skillLines[$i+1]),0,7)=="include" && $i+1<count($skillLines))
			$include=trim($skillLines[$i+1]);
		else $include="NONE";
		$class_name=substr(trim($skillLines[$i]),0,-6);
		mssql_query("INSERT INTO class_list (class_name, includes) VALUES ('$class_name', '$include')") or die("Error inserting class_name");
		$class_list[$classCount]=$class_name;
		$classCount++;
	}
}

$skillDataArray = array();
$currentClass="";
for($i=0;$i<count($skillLines);$i++){
	$removedSpaces="";
	if(substr(trim($skillLines[$i]),-6)=="_begin" && substr(trim($skillLines[$i]),0,5)!="skill"){
		$currentClass=substr(trim($skillLines[$i]),0,-6);
		mssql_query("if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[$currentClass]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
					drop table [dbo].[$currentClass]");
		mssql_query("CREATE TABLE [dbo].[$currentClass] (
					[comment] [varchar] (255) ,
					[skill_name] [varchar] (255) ,
					[get_lv] [varchar] (255) ,
					[lv_up_sp] [varchar] (255) ,
					[auto_get] [varchar] (255) ,
					[item_needed] [varchar] (255)
				) ON [PRIMARY] ");
		continue;
	}
	if(substr(trim($skillLines[$i]),0,7)=="include")
		continue;
	if(substr(trim($skillLines[$i]),0,11)=="skill_begin"){
		$reconSkill = trim($skillLines[$i]);
		$reconSkill = str_replace("\t"," ",$reconSkill);
		$tmp = explode(" ",$reconSkill);
		for($b=0;$b<count($tmp);$b++){
			if($b+1 < count($tmp)){
				//adding variables and values
				if(trim($tmp[$b+1]) == "=") {
					$skillDataArray[trim($tmp[$b])] = trim($tmp[$b+2]);
					$b += 2;
				}
			}
		}
	}
	mssql_query("INSERT INTO $currentClass (comment, skill_name, get_lv, lv_up_sp, auto_get, item_needed) VALUES (
				'/* [comment] */',
				'".$skillDataArray['skill_name']."',
				'".$skillDataArray['get_lv']."',
				'".$skillDataArray['lv_up_sp']."',
				'".$skillDataArray['auto_get']."',
				'".$skillDataArray['item_needed']."')");
}
?>

<html>
<head>
<title>Import Skillacquire to DB</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>
<body>
<? echo count($skillLines)." lines in file<br>"; ?>
If you get no errors everything is Ok!
</body>
</html>
