--
-- Database: `l2scripts`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `npcdata`
-- 

DROP TABLE IF EXISTS `npcdata`;
CREATE TABLE `npcdata` (
  `id` int(12) NOT NULL auto_increment,
  `class` enum('warrior','merchant','warehouse_keeper','teleporter','citizen','guild_coach','guild_master','guard','package_keeper','summon','object','temptrainer','holything','castle_gate','house_master','blacksmith','boss','pet','chamberlain') NOT NULL default 'warrior',
  `title` varchar(75) NOT NULL default '',
  `level` int(2) NOT NULL default '1',
  `exp` decimal(12,3) NOT NULL default '1.000',
  `acquire_exp_rate` varchar(50) NOT NULL default '1,1',
  `undying` enum('0','1') NOT NULL default '0',
  `can_be_attacked` enum('0','1') NOT NULL default '1',
  `acquire_sp` int(12) NOT NULL default '1',
  `race` enum('fairy','animal','humanoid','plant','elemental','undead','construct','bug','beast','demonic','monster','dragon','giant','human','dwarf','elf','darkelf','orc','mercenary','castle_guard') NOT NULL default 'fairy',
  `sex` enum('male','female') NOT NULL default 'male',
  `temper` int(3) NOT NULL default '100',
  `safe_height` int(4) NOT NULL default '100',
  `org_jump` int(2) NOT NULL default '0',
  `skill_list` text,
  `magic_list` varchar(255) default NULL,
  `max_item` int(3) NOT NULL default '0',
  `item_make_list` varchar(255) default NULL,
  `corpse_make_list` varchar(255) default NULL,
  `additional_make_list` varchar(255) default NULL,
  `additional_make_multi_list` text,
  `slot_chest` varchar(50) default NULL,
  `slot_rhand` varchar(50) default NULL,
  `slot_lhand` varchar(50) default NULL,
  `base_attack_type` enum('fist','blunt','bow','sword','dagger','pole','none') NOT NULL default 'none',
  `base_can_penetrate` enum('0','1') NOT NULL default '0',
  `base_attack_range` int(4) NOT NULL default '0',
  `base_damage_range` varchar(20) NOT NULL default '{0;0;0;0}',
  `base_rand_dam` int(4) NOT NULL default '0',
  `str` int(3) NOT NULL default '0',
  `int` int(3) NOT NULL default '0',
  `dex` int(3) NOT NULL default '0',
  `wit` int(3) NOT NULL default '0',
  `con` int(3) NOT NULL default '0',
  `men` int(3) NOT NULL default '0',
  `hp_increase` int(3) NOT NULL default '0',
  `mp_increase` int(2) NOT NULL default '0',
  `org_hp_regen` decimal(4,1) NOT NULL default '0.0',
  `org_mp_regen` decimal(4,1) NOT NULL default '0.0',
  `ground_low` varchar(15) NOT NULL default '{0;0;0}',
  `ground_high` varchar(15) NOT NULL default '{0;0;0}',
  `underwater_low` varchar(15) NOT NULL default '{0;0;0}',
  `underwater_high` varchar(15) NOT NULL default '{0;0;0}',
  `fly_low` varchar(15) NOT NULL default '{0;0;0}',
  `fly_high` varchar(15) NOT NULL default '{0;0;0}',
  `float_low` varchar(15) NOT NULL default '{0;0;0}',
  `float_high` varchar(15) NOT NULL default '{0;0;0}',
  `org_earshot` int(3) NOT NULL default '0',
  `sight` varchar(20) NOT NULL default '{0;0;0;0;0}',
  `agro_range` int(4) NOT NULL default '0',
  `org_hp` decimal(22,13) NOT NULL default '0.0000000000000',
  `org_mp` decimal(12,3) NOT NULL default '0.000',
  `base_defend` decimal(24,13) NOT NULL default '0.0000000000000',
  `base_magic_attack` decimal(24,13) NOT NULL default '0.0000000000000',
  `base_magic_defend` decimal(24,13) NOT NULL default '0.0000000000000',
  `base_physical_attack` decimal(24,13) NOT NULL default '0.0000000000000',
  `physical_hit_modify` decimal(4,2) NOT NULL default '0.00',
  `physical_avoid_modify` enum('0','1','-18') NOT NULL default '0',
  `base_attack_speed` int(3) NOT NULL default '253',
  `base_reuse_delay` int(4) NOT NULL default '0',
  `base_critical` enum('1','4','8') NOT NULL default '1',
  `magic_use_speed_modify` int(1) NOT NULL default '0',
  `status` varchar(10) NOT NULL default '{normal}',
  `align` int(4) NOT NULL default '0',
  `collision_radius` decimal(4,1) NOT NULL default '0.0',
  `collision_height` decimal(4,1) NOT NULL default '0.0',
  `category` varchar(10) NOT NULL default '{}',
  `clan` enum('{}','{@goblin_clan}','{@demonic_clan}','{@orc_clan}','{-1}','{@lizardman_clan}','{@werewolf_clan}','{@elemental1_clan}','{@skeleton_clan}','{@elemental2_clan}','{@wererat_clan}','{@ol_mahum_clan}','{@bugbear_clan}','{@scropio_clan}','{@ant_clan}','{@elemental3_clan}','{@elemental4_clan}','{@all_elemental_clan}','{@all_elemental2_clan}','{@undead_clan}','{@dragon_clan}','{@mandragora_clan}','{@stakato_clan}','{@neer_crawler_clan}','{@oel_mahum_clan}','{@serpent_clan}','{@silenos_clan}','{@tyrant_clan}','{@wolf_clan}','{@porta_clan}','{@torfe_clan}','{@giant_leech_clan}','{@cave_servant_clan}','{@succubus_clan}','{@ghost_clan}','{@monster_eye_clan}','{@elemental_clan}','{@kobold_clan}','{@malruk_clan}','{@mirrorforest_clan}','{@giant_clan}','{@hatar_clan}','{@partisan_clan}','{@q403_clan}','{@abyss_jewel_clan}','{@grave_guard_clan}','{@grave_keeper_clan}','{@door_clan;@gludio_siege_clan}','{@orfen_clan}','{@door_clan;@oren_siege_clan}','{@door_clan;@aden_siege_clan}','{@door_clan;@mercenary_siege_clan}','{@queen_ant_clan}','{@curma_core_clan}','{@door_clan;@dion_siege_clan}','{@door_clan;@giran_siege_clan}') NOT NULL default '{}',
  `clan_help_range` int(4) NOT NULL default '0',
  `guild` varchar(10) NOT NULL default '{}',
  `pledge` varchar(10) NOT NULL default '{}',
  `pledge_leader` int(1) NOT NULL default '0',
  `alliance` varchar(10) NOT NULL default '{}',
  `alliance_leader` int(1) NOT NULL default '0',
  `ignore_clan_list` text,
  `ruler` int(1) NOT NULL default '0',
  `ruling_domain` varchar(10) NOT NULL default '{}',
  `npc_ai` text,
  `corpse_time` int(3) NOT NULL default '0',
  `no_sleep_mode` enum('0','1') NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
